<?php

/*
 * W2 1.0.1
 *
 * Copyright (C) 2007 Steven Frank <http://stevenf.com/>
 * Code may be re-used as long as the above copyright notice is retained.
 * See README.txt for full details.
 *
 * Written with Coda: <http://panic.com/coda/>
 */
 
include_once "markdown.php";

// User configurable options:

include_once "config.php";


// Global variables
$titles = array( "all" => "All Pages",
		"upload" => "Upload Image",
		"new"	=> "New",
		"search" => "Search" );

// Support functions

function printToolbar($title)
{
	global $upage, $page;

	print "<div class=\"toolbar\">";
	
	print renderButton("Pages", "pages", BASE_URI . "/index.php?action=all");
	print renderButton("New", "new", BASE_URI . "/index.php?action=new");
	
	print "<a id=\"headertext\" href=\"" . BASE_URI . "/index.php?action=edit&amp;page=$upage\">$title</a>";


/*
	if ( ! DISABLE_UPLOADS )
		print "<a class=\"tool\" href=\"" . BASE_URI . "/index.php?action=upload\">Upload</a> ";

 	
	print "<a class=\"tool\" href=\"" . BASE_URI . "/index.php?action=images\">All Files</a> ";
 	print "<a class=\"tool\" href=\"" . BASE_URI . "/index.php\">". DEFAULT_PAGE . "</a>";
*/

	print "</div>\n";
}

function printBottombar()
{
	$base = BASE_URI;
	
	$images = renderButton("Files", "images", "$base/index.php?action=images");
	$upload = renderButton("Upload", "upload", "$base/index.php?action=upload");

	$bar = <<<EOL
<div class="toolbar" id="bottom">
$images $upload
<form id="searchform" method="post" action="$base/index.php?action=search">
<div><input type="search" name="q" /></div></form>
</div>

EOL;

	print $bar;
}

function renderButton($text, $id, $link)
{
	$base = BASE_URI;

	$button = <<<EOL
<div class="button" id="$id"><img class="left" src="$base/interface/button-main-left.png" alt="left" /><img class="right" src="$base/interface/button-main-right.png" alt="right" />
<a href="$link">$text</a></div>	
EOL;

	return $button;
}

function renderDeleteButton($text, $id, $link)
{
	$base = BASE_URI;

	$button = <<<EOL
<div class="button delete" id="$id"><img class="left" src="$base/interface/button-delete-left.png" alt="left" /><img class="right" src="$base/interface/button-delete-right.png" alt="right" />
<a href="$link">$text</a></div>	
EOL;

	return $button;
}

function toHTML($inText)
{
	global $page;

 	$inText = preg_replace("/\[\[(.*?)\]\]/", "<a href=\"" . BASE_URI . "/index.php/\\1\">\\1</a>", $inText);
	$inText = preg_replace("/\{\{(.*?)\}\}/", "<img src=\"" . BASE_URI. "/images/\\1\" alt=\"\\1\" />", $inText);
	$html .= Markdown($inText);

	return $html;
}

function sanitizeFilename($inFileName)
{
	return str_replace(array('..', '~', '/', '\\', ':'), '-', $inFileName);
}

// Support PHP4 by defining file_put_contents if it doesn't already exist

if ( !function_exists('file_put_contents') )
{
    function file_put_contents($n,$d)
    {
		$f = @fopen($n,"w");
		if ( !$f )
		{
			return false;
		}
		else
		{
			fwrite($f,$d);
			fclose($f);
			return true;
		}
    }
}

// Main code

if ( isset($_REQUEST['action']) )
	$action = $_REQUEST['action'];
else 
	$action = '';

if ( preg_match('@^/@', $_SERVER["PATH_INFO"]) ) 
	$page = sanitizeFilename(substr($_SERVER["PATH_INFO"], 1));
else 
	$page = sanitizeFilename($_REQUEST['page']);

$upage = urlencode($page);

if ( $page == "" )
	$page = DEFAULT_PAGE;

$filename = BASE_PATH . "/pages/$page.txt";

if ( file_exists($filename) )
{
	$text = file_get_contents($filename);
}
else
{
	if ( $action != "save" )
		$action = "edit";
}

// Figure out which action render function to call
$func = "show$action" . '($action, $page, $html);';
eval($func);

// Map the action to a title
$title = ($titles[$action] == '')? $page : $titles[$action];

// Disable caching on the client (the iPhone is pretty agressive about this
// and it can cause problems with the editing function)

header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Date in the past

print "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n";
print "<html>\n";
print "<head>\n";
print "<meta name=\"viewport\" content=\"width=320; initial-scale=1.0; maximum-scale=1.0; user-scalable=0;\"/>\n";

print "<script type=\"application/x-javascript\">
    
    addEventListener(\"load\", function()
    {
        setTimeout(hideURLbar, 0);
    }, false);
    
    function hideURLbar()
    {
        window.scrollTo(0, 1);
    }

</script>\n";

print "<link type=\"text/css\" rel=\"stylesheet\" href=\"" . BASE_URI . "/" . CSS_FILE ."\" />\n";
print "<title>$title</title>\n";
print "</head>\n";
print "<body>\n";

printToolbar($title);

print "<div class=\"main\">\n";
print "$html\n";
print "</div>\n";

printBottombar();

print "</body>\n";
print "</html>\n";



// Action render functions
function shownew($action, $page, &$html)
{

	$html = "<form id=\"edit\" method=\"post\" action=\"" . BASE_URI . "/index.php\">\n";
	$html .= "<p>Title: <input id=\"title\" type=\"text\" name=\"page\" /></p>\n";
	
	$html .= "<p><textarea id=\"text\" name=\"newText\" rows=\"18\" cols=\"40\"></textarea></p>\n";
	$html .= "<p><input type=\"hidden\" name=\"action\" value=\"save\" />";
	$html .= "<input id=\"save\" type=\"submit\" class=\"whiteButton\" value=\"Save\" />\n";
	$html .= "<input id=\"cancel\" type=\"button\" class=\"whiteButton\" onclick=\"history.go(-1);\" value=\"Cancel\" /></p>\n";
	$html .= "</form>\n";
	
}

function showedit($action, $page, &$html)
{
	global $text;

	$html = "<form id=\"edit\" method=\"post\" action=\"" . BASE_URI . "/index.php\">\n";

	$html .= "<input type=\"hidden\" name=\"page\" value=\"$page\" />\n";

	$html .= "<p><textarea id=\"text\" name=\"newText\" rows=\"18\" cols=\"40\">$text</textarea></p>\n";
	$html .= "<p><input type=\"hidden\" name=\"action\" value=\"save\" />";
	$html .= "<input id=\"save\" type=\"submit\" class=\"whiteButton\" value=\"Save\" />\n";
	$html .= "<input id=\"cancel\" type=\"button\" class=\"whiteButton\" onclick=\"history.go(-1);\" value=\"Cancel\" /></p>\n";
	$html .= "</form>\n";
}

function showupload($action, $page, &$html)
{
	if ( DISABLE_UPLOADS )
	{
		$html .= "<p>Image uploading has been disabled on this installation.</p>";
	}
	else
	{
		$html .= "<form id=\"upload\" method=\"post\" action=\"" . BASE_URI . "/index.php\" enctype=\"multipart/form-data\"><p>\n";
		$html .= "<input type=\"hidden\" name=\"action\" value=\"uploaded\" />";
		$html .= "<input id=\"file\" type=\"file\" name=\"userfile\" />\n";
		$html .= "<input id=\"upload\" type=\"submit\" value=\"Upload\" />\n";
		$html .= "<input id=\"cancel\" type=\"button\" onclick=\"history.go(-1);\" value=\"Cancel\" />\n";
		$html .= "</p></form>\n";
	}
}

function showuploaded($action, $page, &$html)
{
	if ( !DISABLE_UPLOADS )
	{
		$dstName = sanitizeFilename($_FILES['userfile']['name']);

		if ( move_uploaded_file($_FILES['userfile']['tmp_name'], 
				BASE_PATH . "/images/$dstName") === true ) 
		{
			$html = "<p class=\"note\">File '$dstName' uploaded</p>\n";
		}
		else
		{
			$html = "<p class=\"note\">Upload error</p>\n";
		}
	}

	$html .= toHTML($text);
}

function showall($action, $page, &$html)
{
	$base = BASE_URI;
	$dir = opendir(BASE_PATH . "/pages");

	$html = <<<EOL
<script type="text/javascript">
	var deletebuttonf6 = new Image();
	deletebuttonf6.src = "$base/interface/button-delete-f6.png";
</script>

EOL;
	
	$html .= "<ul id=\"itemlist\">\n";
	
	while ( $file = readdir($dir) )
	{
		if ( $file{0} == "." )
			continue;

		$file = explode(".", $file);
		$file = $file[0];
		
		$delete = renderDeleteButton("Delete", "drb$file", "$base/index.php?action=cdelete&amp;page=$file");
		$html .= <<<EOL
	<li>
		<a class="deletelink" id="dl$file" onclick="var i=document.getElementById('imgdb$file'); var d=document.getElementById('db$file'); if(i.src.indexOf('f6')==-1){i.src='$base/interface/button-delete-f6.png'; d.style.display='inline';}else{i.src='$base/interface/button-delete.png'; d.style.display='none';} return false;" href="$base/index.php?action=delete&amp;page=$file">
			<img id="imgdb$file" src="$base/interface/button-delete.png" />
		</a>
		<div class="deletebutton" id="db$file">
		$delete
		</div>
		<a class="itemtext" href="$base/index.php/$file">$file</a>
	</li>

EOL;
	}

	closedir($dir);
	$html .= "</ul>\n";
}

function showsearch($action, $page, &$html)
{
	$matches = 0;
	$q = $_REQUEST['q'];
	$html = "<h1>Search: $q</h1>\n<ul>\n";

	if ( trim($q) != "" )
	{
		$dir = opendir(BASE_PATH . "/pages");
		
		while ( $file = readdir($dir) )
		{
			if ( $file{0} == "." )
				continue;

			$text = file_get_contents(BASE_PATH . "/pages/$file");
			
			if ( eregi($q, $text) )
			{
				++$matches;
				$file = preg_replace("/(.*?)\.txt/", "<a href=\"" . BASE_URI . "/index.php/\\1\">\\1</a>", $file);
				$html .= "<li>$file</li>\n";
			}
		}
		
		closedir($dir);
	}

	$html .= "</ul>\n";
	$html .= "<p>$matches matched</p>\n";
}

function showsave($action, $page, &$html)
{
	global $filename;

	$newText = trim(stripslashes($_REQUEST['newText']));
	file_put_contents($filename, $newText);
		
	$html = "<p class=\"note\">Saved</p>\n";
	$html .= toHTML($newText);
}

function showdelete($action, $page, &$html)
{
	$base = BASE_URI;
	$html = <<<FOOBAR
<p>Are you sure you want to delete this page? $page</p>
<form id="delete" method="post" action="$base/index.php">
<input type="hidden" name="page" value="$page" />
<p><input type="hidden" name="action" value="cdelete" />
<input id="save" type="submit" value="Delete" />
<input id="cancel" type="button" onclick="history.go(-1);" value="Cancel" /></p>
</form>
FOOBAR;

}

function showcdelete($action, $page, &$html)
{
	global $filename;

	$base = BASE_URI;
	unlink($filename);
	header( "Location: $base/index.php?action=all" );
	return;
}

function showimages($action, $page, &$html)
{
	$base = BASE_URI;
	$dir = opendir(BASE_PATH . "/images");

	$html = <<<EOL
<script type="text/javascript">
	var deletebuttonf6 = new Image();
	deletebuttonf6.src = "$base/interface/button-delete-f6.png";
	var deletebutton = new Image();
	deletebutton.src = "$base/interface/button-delete.png";
</script>

EOL;

	$html .= "<ul id=\"itemlist\">\n";

	while ( $file = readdir($dir) )
	{
		if ( $file{0} == "." )
			continue;
			
		$delete = renderDeleteButton("Delete", "drb$file", "$base/index.php?action=delimage&amp;image=$file");

		$html .= <<<EOL
	<li>
		<a class="deletelink" id="dl$file" onclick="var i=document.getElementById('imgdb$file'); var d=document.getElementById('db$file'); if(i.src.indexOf('f6')==-1){i.src='$base/interface/button-delete-f6.png'; d.style.display='inline';}else{i.src='$base/interface/button-delete.png'; d.style.display='none';} return false;" href="$base/index.php?action=delimage&amp;image=$file">
			<img id="imgdb$file" src="$base/interface/button-delete.png" />
		</a>
		<div class="deletebutton" id="db$file">
		$delete
		</div>
		
		<a class="itemtext" href="$base/images/$file">$file</a>
	</li>
	
EOL;
	}
		
//		$html .= "<li><a href=\"index.php?action=image&image=$file\">$file</a> <a href=\"index.php?action=delimage&image=$file\">delete</a> </li>\n";

	closedir($dir);
	$html .= "</ul>\n";
}

function showimage($action, $page, &$html)
{
	$base = BASE_URI;

	$html = <<<EOS
<embed src="$base/images/{$_REQUEST['image']}" />
EOS;
}

function showdelimage($action, $page, &$html)
{
	$base = BASE_URI;
	unlink(BASE_PATH . "/images/{$_REQUEST['image']}");
	header( "Location: $base/index.php?action=images" );
	return;
}

function show($action, $page, &$html)
{
	global $text;
	$html = "<div id=\"pageContent\">";
	$html .= toHTML($text);
	$html .= "</div>";
}
?>
